#include <VirtualWire.h>

// Sensors 
int leftArm;
int rightArm;
int leftKnee;
int rightKnee;
int chestPush;

long previousMillis = 0;
long interval = 2000;

char StringReceived[27]; 

void setup() {
  Serial.begin(9600);

  vw_set_rx_pin(11);
  vw_set_ptt_inverted(true);
  vw_setup(4800);
  vw_rx_start();
}

void loop(){
  uint8_t buf[VW_MAX_MESSAGE_LEN];
  uint8_t buflen = VW_MAX_MESSAGE_LEN;

  if (vw_get_message(buf, &buflen)) 
  {
    int i;
    for (i = 0; i < buflen; i++)
    {            
      StringReceived[i] = char(buf[i]);
    }
    sscanf(StringReceived, "%d,%d,%d,%d,%d", &leftArm, &rightArm, &leftKnee, &rightKnee, &chestPush);

  }  

  int leftArmMapped = map(leftArm, 90, 48, 0, 127);
  leftArmMapped = constrain(leftArmMapped, 0, 127);
  if (leftArmMapped > 0) {
    usbMIDI.sendControlChange(10, leftArmMapped, 1);
  }

  Serial.print("left Arm: ");
  Serial.println(leftArm);

  int rightArmMapped = map(rightArm, 120, 57, 0, 127);
  rightArmMapped = constrain(rightArmMapped, 0, 127);
  if (rightArmMapped > 0) {
    usbMIDI.sendControlChange(20, rightArmMapped, 1);
  }

  Serial.print("right Arm: ");
  Serial.println(right Arm);

  int leftKneeMapped = map(leftKnee, 90, 72, 0, 127);
  leftKneeMapped = constrain(leftKneeMapped, 0, 127);
  if (leftKneeMapped > 0) {
    usbMIDI.sendControlChange(30, leftKneeMapped, 1);
  }

  Serial.print("left Knee: ");
  Serial.println(leftKnee);

  int rightKneeMapped = map(rightKnee, 85, 55, 0, 127);
  rightKneeMapped = constrain(rightKneeMapped, 0, 127);
  if (rightKneeMapped > 0) {
    usbMIDI.sendControlChange(40, rightKneeMapped, 1);
  }

  Serial.print("right Knee: ");
  Serial.println(rightKnee);

  unsigned long current Millis = millis();

    if (currentMillis - previousMillis > interval) {
      previousMillis = currentMillis;
      if (chestPush == 80) {
      Serial.print("Chest Push: ");
      Serial.println(chestPush);
      usbMIDI.sendControlChange(50,1,1);
    }
  }


  memset(StringReceived, 0, sizeof(StringReceived));
  while (usbMIDI.read()){
  }
  delay(5);
}
